/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qdialog.h>
#include <qfiledialog.h>
#include <qstring.h>
#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <qmessagebox.h>
#include <qinputdialog.h>
#include <qsyntaxhighlighter.h>
#include <iomanip>

using namespace std;

#include "../sintatico.h"
#include "../lexico.h"
#include "../tabela.h"

QString pathArquivo = "";

void janelaCompilador::fileNew()
{
}


void janelaCompilador::fileOpen()
{

}


void janelaCompilador::fileSave()
{

}


void janelaCompilador::fileSaveAs()
{

}


void janelaCompilador::filePrint()
{

}


void janelaCompilador::fileExit()
{

}


void janelaCompilador::editUndo()
{

}


void janelaCompilador::editRedo()
{

}


void janelaCompilador::editCut()
{

}


void janelaCompilador::editCopy()
{

}


void janelaCompilador::editPaste()
{

}


void janelaCompilador::editFind()
{

}


void janelaCompilador::helpIndex()
{

}


void janelaCompilador::helpContents()
{

}


void janelaCompilador::helpAbout()
{
        QString msg = "<b><font size='+2'>Sobre</font>\
		<br><font size='+1'>Maquina Virtual - Compiladores 2006</font></b>\
		<br>Pontificia Universidade Catolica de Campinas\
		<br>Professor: Ricardo Freitas\
		<br><br><b>Autores:</b>\
		<br>Bruno Mazzoco - RA: 02150522 - brunomazzoco@gmail.com\
		<br>Cesar Kallas - cesarkallas@soulivre.org - RA:02099224\
		<br>Renato Demarco - RA: 02142818 - renatodemarco@gmail.com\
		<br><br>This program is free software; you can redistribute\
		<br>it and or modify it under the terms of the GNU General\
		<br>Public License as published by the Free Software Foundation;\
		<br>either version 2 of the License, or (at your option) any later version.\
		<br>";
    QMessageBox::information( this, "MquinaVirtual - Sobre",  msg, "&Fechar", 0, 0, 0, 1);
    

}

void janelaCompilador::carregaArquivo()
{
    ifstream arquivo;
    std::string i;
    
    // Exibe o dialogo para o usuario escolher o arquivo (apenas .txt)
    QFileDialog *dlg = new QFileDialog(this);
        dlg->setCaption( QFileDialog::tr( "Open" ) );
        dlg->setMode( QFileDialog::ExistingFile );
        dlg->setFilter( "Fontes Compiladores (*.txt)" );
	
        if ( dlg->exec() == QDialog::Accepted ) {
            pathArquivo = dlg->selectedFile();

	 // Abre o arquivo escolhido
	arquivo.open(pathArquivo);
	if(!arquivo.is_open()) {
		cerr << "Falha ao abrir o arquivo";
		pathArquivo = "";
		return;
	}
	
	// Limpa campos do compilador
	textEditar->clear();
	textSaida->clear();
	
	// Pega linha por linha do arquivo e insere na tabela de codigos
	for(int j=0000; getline(arquivo, i, '\n') ; j++) {
	    textEditar->append(QString(i));
	}
	
	textEditar->append(QString("\n"));
	    
	// Habilita botao de compilar
	botaoCompilar->setEnabled(1);
	
	// Exibe o caminho do arquivo na janela
	labelArquivo->setText(pathArquivo);
	
	textEditar->setEnabled(1);
	textEditar->setModified(0);
	textEditar->setFocus();
	arquivo.close();
        }
        delete dlg;
}

void janelaCompilador::novoArquivo()
{
    if(textEditar->isModified()) 
	fecharArquivo();
	
    textEditar->clear();
    textSaida->clear();
    textEditar->setEnabled(1);
    botaoCompilar->setEnabled(1);
    labelArquivo->setText(QString(""));
    textEditar->setModified(0);
    pathArquivo = "";
    textEditar->setFocus();
}


void janelaCompilador::fecharArquivo()
{
    if(textEditar->isModified()) 
	if(QMessageBox::information( this, "Compilador",
                                      "Salvar antes de fechar ?",
                                      "Nao", "Sim",  0, 1 ) == 1)
	    salvarArquivo();
	
    textEditar->clear();
    textSaida->clear();
    textEditar->setEnabled(0);
    botaoCompilar->setEnabled(0);
    textEditar->setModified(0);
    labelArquivo->setText(QString(""));
    pathArquivo = "";
    textEditar->setFocus();
}


void janelaCompilador::salvarArquivo()
{
    if (pathArquivo == "") {
	// Exibe o dialogo para o usuario escolher o caminho para salvar o arquivo
	pathArquivo = QFileDialog::getSaveFileName(); 
    }
    
    ofstream arquivoFonte(pathArquivo, ios::out);
    if (!arquivoFonte) {
	QMessageBox::information( this, "Compilador",
				  "Falha ao salvar arquivo fonte:\n" + pathArquivo
				  );
    }
    else {
	arquivoFonte << textEditar->text();
	arquivoFonte.close();
	textEditar->setModified(0);
	
	// Habilita botao de compilar
	botaoCompilar->setEnabled(1);
	
	// Exibe o caminho do arquivo na janela
	labelArquivo->setText(pathArquivo);
    }
}


void janelaCompilador::compilar()
{
    std::string MSG; 
    lexico ret;
    
    salvarArquivo();
    
    if (pathArquivo == "")
	return;
    
    std::string path=std::string((const char*)pathArquivo);
    
    // Variaveis para manipular arquivo fonte 
    ifstream fonte; 
	 
	// Limpa saida
	textSaida->clear();
	textSaida->append(QString("Iniciando compilao..."));
    
	ret = Sintatico(strdup(pathArquivo));
	if (ret.id == 0) {
	    textSaida->append(QString("Arquivo compilado com sucesso!"));
	}
	else {
	    if (ret.id == -1) {
		textSaida->append(QString("comentario sem fim"));
	    }
	    else {
		// textSaida->append(QString("error "  + "  ~ linha: " + QString::number(0)));    
		textSaida->append(QString("Falha ao compilar: ") + QString(ret.error));    
	    }
	}
}
